LibreOffice: XAggregation Interface Reference

LibreOffice LibreOffice 5.0 SDK API Reference

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
XAggregation Interface Referencepublished

Objects which implement this interface can become aggregates of a delegator. More...

`import"XAggregation.idl";`

Inheritance diagram for XAggregation:

## Public Member Functions
void | setDelegator ([in] com::sun::star::uno::XInterface pDelegator)
| sets the object to which all calls to the method XInterface::queryInterface() have to be forwarded. More...
any | queryAggregation ([in] type aType)
| is similar to XInterface::queryInterface(), but it is to be processed directly without being forwarded to the delegator. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...

## Detailed Description

Objects which implement this interface can become aggregates of a delegator.

That means if an object "A" aggregates "B", "A" can provide all or some of the interfaces of "B". Whenever the method XInterface::queryInterface() is called on either of the objects, the call will be forwarded to object "A". Object "A" now can determine whether to use the interfaces of "A" or "B" or neither. Actually, any number of aggregates can be used, even nested ones (aggregated objects which are delegators by themselves).

The following rules are to be observed:

1. All calls to XInterface::acquire() which are made before the delegator was set (using the method XAggregation::setDelegator()) must not be taken back (using the method XInterface::release()) before the delegation is removed by calling `xAggregation->setDelegator(NULL)`.

2. The constructor of a delegator has to increment its own reference count by calling its method XInterface::acquire() before it sets itself to any aggregate using the method XAggregation::setDelegator(). After that call it has to reset its own reference count without the destructor getting called.

3. The destructor of a delegator has to reset the delegator in its aggregated objects by calling their method XAggregation::setDelegator() with NULL before it releases its reference to its aggregated objects.

Deprecated:
  Aggregation will no longer be supported as a high-level concept of UNO. You may still have the option to implement an UNO object consisting of several single objects in your specific programming language, though this depends on your programming language.

Developers Guide
  WritingUNO - Core Interfaces to Implement
  WritingUNO - XAggregation

## Member Function Documentation

any queryAggregation | ( | [in] type | aType | ) |

is similar to XInterface::queryInterface(), but it is to be processed directly without being forwarded to the delegator.

This method is only called from within an implementation of XInterface::queryInterface() or XAggregation::queryAggregation(). This method is to be called by the delegator if it does not implement the interface itself. An object which got aggregated cannot depend on getting its own interface when it calls the method XInterface::queryInterface().

See also
  XAggregation::setDelegator

void setDelegator | ( | [in] com::sun::star::uno::XInterface | pDelegator | ) |

sets the object to which all calls to the method XInterface::queryInterface() have to be forwarded.

Parameters

  pDelegator | specifies the object which handles the calls to XInterface::queryInterface(). If pDelegator is NULL, the delegator is removed and thus the object becomes its own delegator and has to handle calls to the method XInterface::queryInterface() itself.

See also
  XAggregation::queryAggregation

The documentation for this interface was generated from the following file:

- com/sun/star/uno/XAggregation.idl